﻿using System;
using System.Collections.Generic;
using UnityEngine;
using TMPro;

public class GameManager : MonoBehaviour
{
    public List<PlayerController> players = new List<PlayerController>();
    public List<System.Tuple<string, PlayerScore>> scores = new List<System.Tuple<string, PlayerScore>>();
    public GridLayout gridLayout;
    public FoodManager foodManager;
    public TextMeshProUGUI[] topScores;
    private float CurrentTime;
    // Start is called before the first frame update
    void Start()
    {
        foodManager = GetComponent<FoodManager>();
        CurrentTime = Time.time * 1000;
    }

    public void UpdateScoreTable()
    {
        if (Time.time * 1000 - CurrentTime > 200)
        {
            Sort(scores);
            CurrentTime = Time.time * 1000;
            //scores.OrderBy(x => x.Value.score);
            int tmp = 0;
            foreach (var topsc in topScores)
            {
                if (tmp < scores.Count)
                {
                    topsc.SetText(scores[scores.Count - 1 - tmp].Item1 + "  " + scores[scores.Count - 1 - tmp].Item2.score);
                    tmp++;
                }
            }
        }
    }
    // Update is called once per frame
    public bool CheckForPlayer(PlayerController playa, int[] pos, Vector2 requestedPosT)
    {
        foreach (var player in players)
        {
            if (player != playa)
            {
                if ((player.requestedPos - requestedPosT).sqrMagnitude < 0.01f)
                {
                    return true;
                }
                if ((player.currentGridPos[0] == pos[0] && player.currentGridPos[1] == pos[1]))
                { return true; }
            }
        }
        return false;
    }

    private void Sort(List<System.Tuple<string, PlayerScore>> scores)
    {
        Comparator comparator = new Comparator();
        scores.Sort(comparator);
    }

    private class Comparator : IComparer<System.Tuple<string, PlayerScore>>
    {
        public int Compare(System.Tuple<string, PlayerScore> x, System.Tuple<string, PlayerScore> y)
        {
            int a = x.Item2.score;
            int b = y.Item2.score;
            if (a > b) return 1;
            else if (a < b) return -1;
            else return 0;
        }
    }

    public bool CheckMapCol(int[] pos)
    {
        if (gridLayout.Width < pos[0] || pos[0] < 0 || gridLayout.Height < pos[1] || pos[1] < 0)
            return true;

        if (gridLayout.GetGridCell(pos[0], pos[1]).Collidable == true)
        {
            return true;
        }
        return false;
    }
}
