﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MoveDispenser : MonoBehaviour
{
    public NetworkControllerScript ncs;
    public GameObject playerPref;
    private Dictionary<string, PlayerController> players = new Dictionary<string, PlayerController>();
    private List<InstructionObject> newInstructions;
    public bool noNetwork;
    private FakeNetwork fakeNetwork;
    private GameManager manager;

    private List<int[]> colorList;
    private int currentColor;
    // Start is called before the first frame update
    void Start()
    {
        colorList = new List<int[]>() {
        new int[]{230, 25, 75},
        new int[]{60, 180, 75},
        new int[]{255, 225, 25},
        new int[]{0, 130, 200},
        new int[]{245, 130, 48},
        new int[]{145, 30, 180},
        new int[]{70, 240, 240},
        new int[]{240, 50, 230},
        new int[]{210, 245, 60},
        new int[]{250, 190, 190},
        new int[]{0, 128, 128},
        new int[]{230, 190, 255},
        new int[]{170, 110, 40},
        new int[]{255, 250, 200},
        new int[]{128, 0, 0},
        new int[]{170, 255, 195},
        new int[]{128, 128, 0},
        new int[]{255, 215, 180},
        new int[]{0, 0, 128},
        new int[]{128, 128, 128},
        new int[]{255, 255, 255},
        new int[]{0, 0, 0},
        };


        manager = GetComponent<GameManager>();
        fakeNetwork = GetComponent<FakeNetwork>();
    }

    // Update is called once per frame
    void Update()
    {
        if (noNetwork)
        {
            newInstructions = fakeNetwork.GetInstructionObjects();
            foreach (var instruction in newInstructions)
            {
                if (players.ContainsKey(instruction.ID))
                {
                    players[instruction.ID].SetNextMove(instruction.Action);
                }
                else
                {
                    Vector2 wPos;
                    manager.gridLayout.GetWorldPosFromCellIndexes(5, 5, out wPos);
                    // do
                    // {
                    Vector3 spawnPos = new Vector3(Random.Range(-wPos.x, wPos.x), 1, Random.Range(-wPos.y, wPos.y));
                    players[instruction.ID] = Object.Instantiate(playerPref, spawnPos, Quaternion.identity).GetComponent<PlayerController>();
                    players[instruction.ID].manager = manager;
                    players[instruction.ID].gridLayout = manager.gridLayout;
                    manager.players.Add(players[instruction.ID]);
                    players[instruction.ID].SetNextMove(instruction.Action);
                    players[instruction.ID].ID = instruction.ID;
                    manager.scores.Add(new System.Tuple<string, PlayerScore>(instruction.Name, players[instruction.ID].score));
                    Color color = new Color(colorList[currentColor][0] / 255f, colorList[currentColor][1] / 255f, colorList[currentColor][2] / 255f, 1);

                    players[instruction.ID].SetColor(color);
                    currentColor++;
                    if (currentColor > colorList.Count - 1)
                    {
                        currentColor = 0;
                    }
                    // colorList.RemoveAt(0);
                }
            }
        }
        else
        {
            newInstructions = ncs.GetInstructionObjects();
            foreach (var instruction in newInstructions)
            {
                if (players.ContainsKey(instruction.ID))
                {
                    if (instruction.Action == 8)
                    {
                        //kill procedure
                        //  colorList.Add(players[instruction.ID].Color);
                        Destroy(players[instruction.ID].gameObject);
                    }
                    else
                    {
                        players[instruction.ID].SetNextMove(instruction.Action);
                    }
                }
                else
                {
                    Vector2 wPos;
                    manager.gridLayout.GetWorldPosFromCellIndexes(5, 5, out wPos);
                    // do
                    // {
                    Vector3 spawnPos = new Vector3(Random.Range(-wPos.x, wPos.x), 1, Random.Range(-wPos.y, wPos.y));
                    players[instruction.ID] = Object.Instantiate(playerPref, spawnPos, Quaternion.identity).GetComponent<PlayerController>();
                    players[instruction.ID].networkControllerScript = ncs;
                    players[instruction.ID].manager = manager;
                    players[instruction.ID].gridLayout = manager.gridLayout;
                    manager.players.Add(players[instruction.ID]);
                    players[instruction.ID].SetNextMove(instruction.Action);
                    players[instruction.ID].ID = instruction.ID;
                    manager.scores.Add(new System.Tuple<string, PlayerScore>(instruction.Name, players[instruction.ID].score));

                    Color color = new Color(colorList[currentColor][0] / 255f, colorList[currentColor][1] / 255f, colorList[currentColor][2] / 255f, 1);
                    players[instruction.ID].SetColor(color);
                    //                    players[instruction.ID].Color = color;


                    List<FeedbackObject> fb = new List<FeedbackObject>()
                    {
                        new FeedbackObject()
                        {
                            ID = instruction.ID,
                            Action = "C" +  (colorList[currentColor][0]).ToString("X2") +
                                            (colorList[currentColor][1]).ToString("X2") +
                                            (colorList[currentColor][2]).ToString("X2")
                        }
                    };
                    currentColor++;
                    if (currentColor > colorList.Count - 1)
                    {
                        currentColor = 0;
                    }
                    // colorList.RemoveAt(0);
                    ncs.SendFeedback(fb);

                }
            }
        }


    }

}
